//
//  BrainStem.java
//  Trikebot
//
//  Created by Andrs Santiago Prez-Bergquist on Wed Jun 05 2002.
//  Copyright (c) 2002. All rights reserved.
//


import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class BrainStem extends java.lang.Object
{
	TrikebotController trikebot;

	public BrainStem()
	{
	}

	public boolean InitBrainStem(TrikebotController t)
	{
		trikebot = t;
		return true;
	}
	
	public String SetP(int P)
	{
		byte P_HI = ByteUtil.Hi(P);
		byte P_LO = ByteUtil.Lo(P);

		byte[] theBytes = new byte[7];
		theBytes[0] = 4;
		theBytes[1] = 5;
		theBytes[2] = 63;
		theBytes[3] = 1;
		theBytes[4] = 1;
		theBytes[5] = P_HI;
		theBytes[6] = P_LO;
		return trikebot.BrainStemDialogue(theBytes);
	}

	public String SetI(int I)
	{
		byte I_HI = ByteUtil.Hi(I);
		byte I_LO = ByteUtil.Lo(I);

		byte[] theBytes = new byte[7];
		theBytes[0] = 4;
		theBytes[1] = 5;
		theBytes[2] = 63;
		theBytes[3] = 1;
		theBytes[4] = 2;
		theBytes[5] = I_HI;
		theBytes[6] = I_LO;
		return trikebot.BrainStemDialogue(theBytes);
	}

	public String SetD(int D)
	{
		byte D_HI = ByteUtil.Hi(D);
		byte D_LO = ByteUtil.Lo(D);

		byte[] theBytes = new byte[7];
		theBytes[0] = 4;
		theBytes[1] = 5;
		theBytes[2] = 63;
		theBytes[3] = 1;
		theBytes[4] = 3; // or 4?
		theBytes[5] = D_HI;
		theBytes[6] = D_LO;
		return trikebot.BrainStemDialogue(theBytes);
	}

	public String SetPeriod(int Period)
	{
		byte Period_HI = ByteUtil.Hi(Period);
		byte Period_LO = ByteUtil.Lo(Period);

		byte[] theBytes = new byte[7];
		theBytes[0] = 4;
		theBytes[1] = 5;
		theBytes[2] = 63;
		theBytes[3] = 1;
		theBytes[4] = 6;
		theBytes[5] = Period_HI;
		theBytes[6] = Period_LO;
		return trikebot.BrainStemDialogue(theBytes);
	}

	public String SetLatency(int Latency)
	{
		byte Latency_HI = ByteUtil.Hi(Latency);
		byte Latency_LO = ByteUtil.Lo(Latency);

		byte[] theBytes = new byte[7];
		theBytes[0] = 4;
		theBytes[1] = 5;
		theBytes[2] = 63;
		theBytes[3] = 1;
		theBytes[4] = 7;
		theBytes[5] = Latency_HI;
		theBytes[6] = Latency_LO;
		return trikebot.BrainStemDialogue(theBytes);
	}
}
