import java.lang.*;

public class TypeC extends java.lang.Object
{
    public int x1, y1, x2, y2, pixels, conf;
	
	public TypeC()
	{
        x1 = y1 = x2 = y2 = pixels = conf = -1;
	}
    
    public boolean parseString(String CString)
	{
        // check for C at beginning
        // peel and integerize each number in turn; trim the string
        String tempStr, newStr;
		int len = CString.length();
		int whiteIndex;
        if (len < 13) return false;
        if (CString.charAt(0) != 'C') return false;
        newStr = CString.substring(2, len);
        whiteIndex = newStr.indexOf(' ');
        if (whiteIndex == -1) return false;
        tempStr = newStr.substring(0, whiteIndex);
        try
		{
			x1 = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			y1 = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			x2 = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			y2 = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			pixels = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			conf = Integer.parseInt(newStr);
        }
		catch (NumberFormatException e)
        {
            System.err.println("PacketC: parse error");
            return false;
        }        
        return true;
    }
    
    public boolean rawParseString(String CString)
	{
        // check for C at beginning
        // peel and integerize each number in turn; trim the string
        int len = CString.length();
        if (len < 7) return false;
        if (CString.charAt(0) != 'C') return false;
        x1     = (int) CString.charAt(1);
        y1     = (int) CString.charAt(2);
        x2     = (int) CString.charAt(3);
        y2     = (int) CString.charAt(4);
        pixels = (int) CString.charAt(5);
        conf   = (int) CString.charAt(6);        
        return true;
    }
}