import java.lang.*;

public class TypeM extends java.lang.Object
{
    public int mx, my, x1, y1, x2, y2, pixels, conf;
	
	public TypeM()
	{
        mx = my = x1 = y1 = x2 = y2 = pixels = conf = -1;
    }
    
    public boolean parseString(String MString)
	{
        // check for M at beginning
        // peel and integerize each number in turn; trim the string
        String tempStr, newStr;
		int len = MString.length();
		int whiteIndex;
        // len should be quite large, but we will attempt to peel at least the
        // mass x and y whenever possible on a partial packet
        if (len < 6) return false;
        if (MString.charAt(0) != 'M') return false;
        newStr = MString.substring(2, len);
        whiteIndex = newStr.indexOf(' ');
        if (whiteIndex == -1) return false;
        tempStr = newStr.substring(0, whiteIndex);
        try
		{
			mx = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;        
			tempStr = newStr.substring(0, whiteIndex);        
			my = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			
			//TEMP
			//         System.err.println("mx= " + mx + " my= " + my); //TEMP
			
			if (len < 17) return false; // quit early if this is a partial packet
			// but note that in this case we still updated mx and my if possible! //
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);        
			x1 = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			y1 = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			x2 = Integer.parseInt(tempStr);
			if (x2 > 80) { x2 = 80; return false; }
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			y2 = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			pixels = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			conf = Integer.parseInt(newStr);
        }
		catch (NumberFormatException e)
        {
            System.err.println("PacketM: parse error");
            return false;
        }
        return true;
    }
    
    public boolean rawParseString(String MString)
	{
        // check for M at beginning
		int len = MString.length();
        if (len < 9) return false;
        if (MString.charAt(0) != 'M') return false;
        mx     = (int) MString.charAt(1);
        my     = (int) MString.charAt(2);
        x1     = (int) MString.charAt(3);
        y1     = (int) MString.charAt(4);
        x2     = (int) MString.charAt(5);
        y2     = (int) MString.charAt(6);
        pixels = (int) MString.charAt(7);
        conf   = (int) MString.charAt(8);        
        return true;
    }
}