//
//  UserThread.java
//  Trikebot
//
//  Created by Andrs Santiago Prez-Bergquist on Fri Jun 14 2002.
//  Copyright (c) 2002. All rights reserved.
//

public class UserThread extends java.lang.Thread
{
	boolean				quit;
	UserWindow			theWindow;
	TrikebotController	trikebot;
	int					function;
	
	public UserThread(TrikebotController t, UserWindow w, int f)
	{
		theWindow 	= w;
		trikebot	= t;
		function	= f;
		quit		= false;
	}

	public void destroy()
	{
		quit = true;
	}

	public void run()
	{
		switch (function)
		{
			case 0: CameraClick(X(), Y(), R(), G(), B()); break;
			case 1:	Action1();	break;
			case 2:	Action2();	break;
			case 3:	Action3();	break;
			case 4:	Action4();	break;
			case 5:	Action5();	break;
			case 6:	Action6();	break;
			case 7:	Action7();	break;
			case 8:	Action8();	break;
			case 9:	Action9();	break;
			case 10:Action10();	break;
		}
	}

	private boolean Loop()
	{
		return (!quit && (theWindow.thread == this));
	}

	private void WaitForCameraClick()
	{
		trikebot.root.theFramegrabWindow.WaitForClick();
	}

	private int X()
	{
		return trikebot.root.theFramegrabWindow.LastX();
	}

	private int Y()
	{
		return trikebot.root.theFramegrabWindow.LastY();
	}

	private int R()
	{
		return trikebot.camera.pic.RedAt(X(), Y());
	}

	private int G()
	{
		return trikebot.camera.pic.RedAt(X(), Y());
	}

	private int B()
	{
		return trikebot.camera.pic.RedAt(X(), Y());
	}
	
	/* CHANGE BUTTONS TO ACTUALLY DO THINGS HERE
	 *
	 * Each function corresponds to the similarly-labeled button
	 * Don't change the function names, just call one of your functions after the comment
	 *
	 * If you understand what you're doing, you can just call your functions directly from the
	 * switch statement above.
	 */

	private void CameraClick(int x, int y, int r, int g, int b)
	{
		// Call your function here
	}
	
	private void Action1()
	{
		// Call your function here
	}

	private void Action2()
	{
		// Call your function here
	}

	private void Action3()
	{
		// Call your function here
	}

	private void Action4()
	{
		// Call your function here
	}

	private void Action5()
	{
		// Call your function here
	}

	private void Action6()
	{
		// Call your function here
	}

	private void Action7()
	{
		// Call your function here
	}

	private void Action8()
	{
		// Call your function here
	}

	private void Action9()
	{
		// Call your function here
	}

	private void Action10()
	{
		// Call your function here
	}

	/* ADD YOUR OWN FUNCTIONS BELOW */

	private void TypicalBehaviorFunction()
	{
		quit = false;
		// Set up anything before the control loop
		while (Loop())
		{
			// Main loop
		}
		// Do any needed cleanup
	}
}
