//
// CalibrationConstants.java
// Trikebot
//
// Created by Andrs Santiago Prez-Bergquist on Mon Jul 08 2002.
// Copyright (c) 2002. All rights reserved.
//

public class CalibrationConstants
{
	// Calibration min/max trikebot parameters
	public int PANMIN = 0;
	public int PANMAX = 240;
	
	public int PANMIN_ANGLE = 59;
	public int PANMAX_ANGLE = -93;
	
	public int TILTMIN = 0;
	public int TILTMAX = 220;
	
	public int TILTMIN_ANGLE = -52;
	public int TILTMAX_ANGLE = 102;
	
	public int TURNMIN = 40;
	public int TURNMAX = 255;
	
	public int TURNMIN_ANGLE = 85;
	public int TURNMAX_ANGLE = -75;
	
	public int WHEEL_FWD_MIN = 5;
	public int WHEEL_FWD_MAX = 50;
	
	public int WHEEL_REV_MIN = -5;
	public int WHEEL_REV_MAX = -50;
	
	public int WHEEL_REV_SPEED = -100;
	public int WHEEL_FWD_SPEED = 100;
}