import java.lang.*;

public class TypeS extends java.lang.Object
{
    public int rMean, gMean, bMean, rDev, gDev, bDev;
	
	public TypeS()
	{
		rMean = gMean = bMean = -1;
		rDev = gDev = bDev = -1;
	}
    
    public int findBlank(String theStr)
	{
        return theStr.indexOf(' ');
    }
    
    public boolean parseString(String SString)
	{
        // check for S at beginning
        // peel and integerize each number in turn; trim the string
        String tempStr, newStr;
		int len = SString.length();
		int whiteIndex;
        if (len < 13) return false;
        if (SString.charAt(0) != 'S') return false;
        //System.err.println("About to parse!");
        newStr = SString.substring(2, len);
        whiteIndex = newStr.indexOf(' ');
        if (whiteIndex == -1) return false;
        tempStr = newStr.substring(0, whiteIndex);
        try
		{
			rMean = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			gMean = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			bMean = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			rDev = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			whiteIndex = newStr.indexOf(' ');
			if (whiteIndex == -1) return false;
			tempStr = newStr.substring(0, whiteIndex);
			gDev = Integer.parseInt(tempStr);
			newStr = newStr.substring(whiteIndex+1);
			bDev = Integer.parseInt(newStr);
        }
		catch (NumberFormatException e)
        {
            System.err.println("PacketS: parse error");
            return false;
        }          
        return true;
    }

    public boolean rawParseString(String SString)
	{
        // check for S at beginning
        // peel and integerize each number in turn; trim the string
        int len = SString.length();
        if (len < 7) return false;
        if (SString.charAt(0) != 'S') return false;
        rMean = (int) SString.charAt(1);
        gMean = (int) SString.charAt(2);
        bMean = (int) SString.charAt(3);
        rDev  = (int) SString.charAt(4);
        gDev  = (int) SString.charAt(5);
        bDev  = (int) SString.charAt(6);        
        return true;
    }
}